<template>
   <div>
        <form v-if="showForm && !isGuest && !isRated">
            <div class="alert alert-danger mb-2" v-if="showError">
                Поставьте оценку товару
            </div>
            <div class="form-group">
                <label for="rating-textarea" class="fs-4 pb-2">Ваш отзыв:</label>
                <textarea
                    class="form-control fs-4"
                    id="rating-textarea"
                    rows="3"
                    name="comment"
                    v-model="comment"></textarea>
                <div class="row w-100 justify-content-between">
                    <div class="col-auto">
                        <star-rating
                            active-color="#ff1f2b"
                            v-model="rating"
                            :increment="0.5"
                            :star-size="30" />
                    </div>
                    <div class="col-auto mt-2 p-0">
                        <button
                            type="button"
                            class="btn btn-danger btn-lg fs-4"
                            @click="submit">Отправить</button>
                    </div>
                </div>
            </div>
        </form>
        <Posts :product-id="productId" :rating-count="ratingCount" />
   </div>
</template>

<script>
    import StarRating from 'vue-star-rating';
    import Posts from './Posts';
    import axios from 'axios';
    import { ratingBus } from '../../app'

    export default {
        components: {
            StarRating,
            Posts
        },
        props: {
            csrf: {
                type: String,
                required: true
            },
            ratingCount: {
                type: String,
                required: true
            },
            isGuest: {
                type: String,
                required: true
            },
        },
        data() {
            return {
                rating: 0,
                comment: '',
                showError: false,
                showForm: true,
                productId: location.pathname.split('/')[2],
                isRated: false
            }
        },
        methods: {
            submit() { 
                if (this.rating < 0.5) {
                    this.showError = true;
                } else {
                    // validation success
                    this.showError = false;
                    axios.post('/product/rating/insert', null, { params: {
                            _token: this.csrf,
                            product_id: this.productId,
                            comment: this.comment,
                            rating: this.rating
                        }})
                        .then(({data}) => {
                            if (data.success == true) {
                                this.showForm = false;
                                ratingBus.$emit('loadPosts')
                            } else {
                                this.showError = true;
                            }
                        })
                        .catch(err => console.warn(err));
                }
            },
            getIsRated() {
                axios.get('/product/rating/is-rated/' + this.productId)
                    .then(({data}) => {
                        this.isRated = data;
                    });
            }
        },
        watch: {
            rating: function (value) {
                this.showError = false;
            }
        },
        mounted() {
            this.getIsRated();
        }
    }
</script>